﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="GaugeExport.aspx.cs" Inherits="GaugeExport" %>

<%@ Register Assembly="Syncfusion.EJ.Web, Version=12.4450.0.34, Culture=neutral, PublicKeyToken=3d67ed1f87d44c89" Namespace="Syncfusion.JavaScript.Web" TagPrefix="ej" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="Scripts/jquery-1.10.2.min.js"></script>
    <script src="Scripts/jquery.easing.1.3.min.js"></script>
    <script src="Scripts/ej.web.all.min.js"></script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <input type="button" onclick="buttonclickevent()" value="Export"/>
        <ej:CircularGauge ID="CircularGauge1" runat="server"><Scales>
           <ej:CircularScales ShowRanges="true" SweepAngle="296" StartAngle="122" Radius="130" ShowScaleBar="true" Size="1" Maximum="120" MajorIntervalValue="20" MinorIntervalValue="10">
               <PointerCap Radius="20"></PointerCap>
               <PointerCollection>
                   <ej:Pointers Value="60" ShowBackNeedle="true" Length="95" Width="7" BackNeedleLength="20" ></ej:Pointers>
               </PointerCollection>
               <Border Width="0.5">
               </Border>
               <TickCollection>
                   <ej:CircularTicks Type="Major" Height="16" Width="1" DistanceFromScale="2" Color="#8c8c8c"/>
                   <ej:CircularTicks Type="Minor" Height="8" Width="1" DistanceFromScale="2" Color="#8c8c8c"/>
               </TickCollection>
               <LabelCollection>
                   <ej:CircularLabels Color="#8c8c8c"></ej:CircularLabels>
               </LabelCollection>
               <RangeCollection>
                   <ej:CircularRanges distanceFromScale="-30" StartValue="0" EndValue="70">
                   </ej:CircularRanges>
                   <ej:CircularRanges BackgroundColor="#fc0606" distanceFromScale="-30" StartValue="70" EndValue="110">
                       <Border Color="#fc0606"></Border>
                   </ej:CircularRanges>
                   <ej:CircularRanges BackgroundColor="#f5b43f" distanceFromScale="-30" StartValue="110" EndValue="120">
                       <Border Color="#f5b43f"></Border>
                   </ej:CircularRanges>
               </RangeCollection>
           </ej:CircularScales>
       </Scales></ej:CircularGauge> 
        <ej:CircularGauge ID="CircularGauge2" runat="server"><Scales>
           <ej:CircularScales ShowRanges="true" SweepAngle="296" StartAngle="122" Radius="130" ShowScaleBar="true" Size="1" Maximum="120" MajorIntervalValue="20" MinorIntervalValue="10">
               <PointerCap Radius="20"></PointerCap>
               <PointerCollection>
                   <ej:Pointers Value="40" ShowBackNeedle="true" Length="95" Width="7" BackNeedleLength="20" ></ej:Pointers>
               </PointerCollection>
               <Border Width="0.5">
               </Border>
               <TickCollection>
                   <ej:CircularTicks Type="Major" Height="16" Width="1" DistanceFromScale="2" Color="#8c8c8c"/>
                   <ej:CircularTicks Type="Minor" Height="8" Width="1" DistanceFromScale="2" Color="#8c8c8c"/>
               </TickCollection>
               <LabelCollection>
                   <ej:CircularLabels Color="#8c8c8c"></ej:CircularLabels>
               </LabelCollection>
               <RangeCollection>
                   <ej:CircularRanges BackgroundColor="red" distanceFromScale="-30" StartValue="0" EndValue="70">
                       <Border Color="red"></Border>
                   </ej:CircularRanges>
                   <ej:CircularRanges BackgroundColor="blue" distanceFromScale="-30" StartValue="40" EndValue="90">
                       <Border Color="blue"></Border>
                   </ej:CircularRanges>
                   <ej:CircularRanges BackgroundColor="violet" distanceFromScale="-30" StartValue="90" EndValue="120">
                       <Border Color="violet"></Border>
                   </ej:CircularRanges>
               </RangeCollection>
           </ej:CircularScales>
       </Scales></ej:CircularGauge>
        <ej:CircularGauge ID="CircularGauge3" runat="server"><Scales>
           <ej:CircularScales ShowRanges="true" SweepAngle="296" StartAngle="122" Radius="130" ShowScaleBar="true" Size="1" Maximum="120" MajorIntervalValue="20" MinorIntervalValue="10">
               <PointerCap Radius="20"></PointerCap>
               <PointerCollection>
                   <ej:Pointers Value="100" ShowBackNeedle="true" Length="95" Width="7" BackNeedleLength="20" ></ej:Pointers>
               </PointerCollection>
               <Border Width="0.5">
               </Border>
               <TickCollection>
                   <ej:CircularTicks Type="Major" Height="16" Width="1" DistanceFromScale="2" Color="#8c8c8c"/>
                   <ej:CircularTicks Type="Minor" Height="8" Width="1" DistanceFromScale="2" Color="#8c8c8c"/>
               </TickCollection>
               <LabelCollection>
                   <ej:CircularLabels Color="#8c8c8c"></ej:CircularLabels>
               </LabelCollection>
               <RangeCollection>
                   <ej:CircularRanges BackgroundColor="green" distanceFromScale="-30" StartValue="0" EndValue="70">
                       <Border Color="green"></Border>
                   </ej:CircularRanges>
                   <ej:CircularRanges BackgroundColor="orange" distanceFromScale="-30" StartValue="20" EndValue="100">
                       <Border Color="orange"></Border>
                   </ej:CircularRanges>
                   <ej:CircularRanges BackgroundColor="black" distanceFromScale="-30" StartValue="100" EndValue="120">
                       <Border Color="black"></Border>
                   </ej:CircularRanges>
               </RangeCollection>
           </ej:CircularScales>
       </Scales></ej:CircularGauge>    
    </div>
    </form>
    <script>
        function buttonclickevent() {
            //To get all the canvas elements
            var canvas1 = $('canvas');
            var b_canvas = new Array();
            for (var l = 0; canvas1[l] != null; l++) {
                b_canvas[l] = canvas1[l];
            }
            //To get only selected canvas elements instead of all canvas element.
            //b_canvas[0] = canvas1[0];
            //b_canvas[1] = canvas1[1];

            //create a temporary canvas to store the combined canvas element.
            var buffer = document.createElement("canvas");
            buffer.width = 0;
            buffer.height = 0;
            //set the total  width and height for Resultant canvas
            for (var i = 0; i < b_canvas.length; i++) {
                buffer.width += b_canvas[i].width;
                buffer.height += b_canvas[i].height;
            }
            var yPosition = 0;
            var buffer_context = buffer.getContext("2d");
            //Draw the canvas
            for (var j = 0; j < b_canvas.length; j++) {
                buffer_context.drawImage(b_canvas[j], 0, yPosition, b_canvas[j].width, b_canvas[j].height);
                yPosition += b_canvas[j].height;
            }
            //method to export all gauges in single file
            exportImage(buffer, "myImage", "png");

        }
        function exportImage(buffer, fileName, fileType) {
            var lnk = document.createElement('a'), e;
            lnk.download = fileName + "." + fileType;
            lnk.href = buffer.toDataURL("image/" + fileType).replace("image/" + fileType, "image/octet-stream");
            if (document.createEvent) {
                e = document.createEvent("MouseEvents");
                e.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
                lnk.dispatchEvent(e);
            } else if (lnk.fireEvent) {
                lnk.fireEvent("onclick");
            }
        }
    </script>
</body>
</html>
